import { isArray, isUndefined } from "../helpers/base";
import { isIterator } from "../iterator/iterator";
import { ArrProto, DONE, VALUE } from "../internal/constants";
export function arrAppend(target, elms) {
    if (!isUndefined(elms) && target) {
        if (isArray(elms)) {
            ArrProto.push.apply(target, elms);
        }
        else if (isIterator(elms)) {
            var value = elms.next();
            while (!value[DONE]) {
                target.push(value[VALUE]);
                value = elms.next();
            }
        }
        else {
            target.push(elms);
        }
    }
    return target;
}
//# sourceMappingURL=append.js.map