import { isNumber, objToString } from "./base";
export function dumpObj(object, format) {
    var objectTypeDump = objToString(object);
    var propertyValueDump = "";
    if (objectTypeDump === "[object Error]") {
        propertyValueDump = "{ stack: '" + object.stack + "', message: '" + object.message + "', name: '" + object.name + "'";
    }
    else {
        if (format) {
            if (isNumber(format)) {
                propertyValueDump = JSON.stringify(object, null, format);
            }
            else {
                propertyValueDump = JSON.stringify(object, null, format ? 4 : 0);
            }
        }
        else {
            propertyValueDump = JSON.stringify(object);
        }
    }
    return objectTypeDump + ": " + propertyValueDump;
}
//# sourceMappingURL=diagnostics.js.map