import { objForEachKey } from "../object/for_each_key";
import { objDeepFreeze } from "../object/object";
export function createEnum(values) {
    var theEnum = {};
    objForEachKey(values, function (field, value) {
        theEnum[field] = value;
        theEnum[value] = field;
    });
    return objDeepFreeze(theEnum);
}
export function createEnumKeyMap(values) {
    var mapClass = {};
    objForEachKey(values, function (key, value) {
        mapClass[key] = key;
        mapClass[value] = key;
    });
    return objDeepFreeze(mapClass);
}
export function createEnumValueMap(values) {
    var mapClass = {};
    objForEachKey(values, function (key, value) {
        mapClass[key] = value;
        mapClass[value] = value;
    });
    return objDeepFreeze(mapClass);
}
export function createSimpleMap(values) {
    var mapClass = {};
    objForEachKey(values, function (field, value) {
        mapClass[field] = value[1];
        mapClass[value[0]] = value[1];
    });
    return objDeepFreeze(mapClass);
}
export function createTypeMap(values) {
    return createSimpleMap(values);
}
//# sourceMappingURL=enum.js.map