import { UNDEFINED } from "../internal/constants";
import { _safeCheck } from "../internal/safe_check";
import { isDefined } from "./base";
var DOCUMENT = "document";
var HISTORY = "history";
var NAVIGATOR = "navigator";
var WINDOW = "window";
var _cachedGlobal = null;
var _hasWindow = _safeCheck(function () { return isDefined(window); }, false);
var _hasDocument = _safeCheck(function () { return isDefined(document); }, false);
var _hasNavigator = _safeCheck(function () { return isDefined(navigator); }, false);
var _hasHistory = _safeCheck(function () { return isDefined(history); }, false);
var _isWebWorker = _safeCheck(function () { return !!(self && self instanceof WorkerGlobalScope); }, false);
var _isNode = _safeCheck(function () { return !!(process && (process.versions || {}).node); }, false);
export function getGlobal(useCached) {
    var result = useCached === false ? null : _cachedGlobal;
    if (!result) {
        if (!result && typeof globalThis !== UNDEFINED) {
            result = globalThis;
        }
        if (!result && typeof self !== UNDEFINED) {
            result = self;
        }
        if (!result && typeof window !== UNDEFINED) {
            result = window;
        }
        if (!result && typeof global !== UNDEFINED) {
            result = global;
        }
        _cachedGlobal = result;
    }
    return result;
}
export function getInst(name, useCached) {
    var gbl = getGlobal(useCached);
    if (gbl && gbl[name]) {
        return gbl[name];
    }
    if (name === WINDOW && _hasWindow) {
        return window;
    }
    return null;
}
export function hasDocument() {
    return !!getDocument();
}
export function getDocument() {
    return _hasDocument ? document : getInst(DOCUMENT);
}
export function hasWindow() {
    return !!getWindow();
}
export function getWindow() {
    return _hasWindow ? window : getInst(WINDOW);
}
export function hasNavigator() {
    return !!getNavigator();
}
export function getNavigator() {
    return _hasNavigator ? navigator : getInst(NAVIGATOR);
}
export function hasHistory() {
    return !!getHistory();
}
export function getHistory() {
    return _hasHistory ? history : getInst(HISTORY);
}
export function isNode() {
    return _isNode;
}
export function isWebWorker() {
    return _isWebWorker;
}
//# sourceMappingURL=environment.js.map