import { dumpObj } from "../helpers/diagnostics";
import { throwTypeError } from "../helpers/throw";
import { EMPTY } from "./constants";
export function _unwrapFunction(funcName) {
    return function (thisArg) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        if ((thisArg || thisArg === EMPTY) && thisArg[funcName]) {
            return thisArg[funcName].apply(thisArg, args);
        }
        throwTypeError("'" + funcName + "' not defined for " + dumpObj(thisArg));
    };
}
export function _unwrapProp(propName) {
    return function (thisArg) {
        return thisArg[propName];
    };
}
//# sourceMappingURL=unwrapFunction.js.map