import { DONE, VALUE } from "../internal/constants";
import { objDefineGet } from "../object/define";
import { getKnownSymbol } from "../symbol/symbol";
export function createIterable(ctx) {
    return makeIterable({}, ctx);
}
export function makeIterable(target, ctx) {
    var itSymbol = getKnownSymbol(3);
    function _createIterator() {
        return createIterator(ctx);
    }
    target[itSymbol] = _createIterator;
    return target;
}
export function createIterator(ctx) {
    var isDone = false;
    function _value() {
        return ctx.v;
    }
    function _next() {
        var _a;
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        isDone = isDone || (ctx.n ? ctx.n(args) : true);
        var result = (_a = {},
            _a[DONE] = isDone,
            _a);
        if (!isDone) {
            objDefineGet(result, VALUE, _value);
        }
        return result;
    }
    function _return(value) {
        var _a;
        return _a = {},
            _a[DONE] = true,
            _a[VALUE] = ctx.r && ctx.r(value),
            _a;
    }
    function _throw(e) {
        var _a;
        return _a = {},
            _a[DONE] = true,
            _a[VALUE] = ctx.t && ctx.t(e),
            _a;
    }
    var theIterator = {
        next: _next
    };
    if (ctx.r) {
        theIterator.return = _return;
    }
    if (ctx.t) {
        theIterator.throw = _throw;
    }
    return theIterator;
}
//# sourceMappingURL=create.js.map