import { DONE, VALUE } from "../internal/constants";
import { getKnownSymbol } from "../symbol/symbol";
import { isIterator } from "./iterator";
export function iterForOf(iter, callbackfn, thisArg) {
    if (iter) {
        if (!isIterator(iter)) {
            var itSymbol = getKnownSymbol(3);
            iter = iter[itSymbol] ? iter[itSymbol]() : null;
        }
        if (isIterator(iter)) {
            try {
                var count = 0;
                var value = iter.next();
                while (!value[DONE]) {
                    if (callbackfn.call(thisArg || iter, value[VALUE], count, iter) === -1) {
                        break;
                    }
                    count++;
                    value = iter.next();
                }
                iter.return && iter.return(value);
            }
            catch (e) {
                iter.throw && iter.throw(e);
            }
        }
    }
}
//# sourceMappingURL=forOf.js.map