import { ObjClass } from "../internal/constants";
import { arrForEach } from "../array/forEach";
import { isArray, isNullOrUndefined, isObject } from "../helpers/base";
import { throwTypeError } from "../helpers/throw";
import { objForEachKey } from "./for_each_key";
var ObjAssign = ObjClass["assign"];
var _objFreeze = ObjClass["freeze"];
function _doNothing(value) {
    return value;
}
export var objAssign = ObjAssign;
export function objKeys(value) {
    if (!isObject(value) || value === null) {
        throwTypeError("objKeys called on non-object");
    }
    return ObjClass.keys(value);
}
export function objDeepCopy(source) {
    if (isArray(source)) {
        var result_1 = [];
        arrForEach(source, function (value) {
            result_1.push(objDeepCopy(value));
        });
        return result_1;
    }
    if (isObject(source)) {
        return objCopyProps({}, source);
    }
    return source;
}
export function objCopyProps(target, source) {
    if (!isNullOrUndefined(source)) {
        objForEachKey(source, function (key, value) {
            target[key] = objDeepCopy(value);
        });
    }
    return target;
}
export function objDeepFreeze(value) {
    if (_objFreeze) {
        objForEachKey(value, function (key, value) {
            if (isArray(value) || isObject(value)) {
                _objFreeze(value);
            }
        });
    }
    return objFreeze(value);
}
export var objFreeze = _objFreeze || _doNothing;
export var objSeal = ObjClass["seal"] || _doNothing;
//# sourceMappingURL=object.js.map