import { arrForEach } from "./array/forEach";
import { ArrCls, ObjClass, StrProto } from "./internal/constants";
import { polyIsArray } from "./polyfills/array";
import { polyObjKeys } from "./polyfills/object";
import { polyStrStartsWith } from "./string/starts_with";
import { polyStrEndsWith } from "./string/ends_with";
import { polyStrTrim, polyStrTrimEnd, polyStrTrimStart } from "./polyfills/trim";
import { polyStrPadEnd, polyStrPadStart } from "./string/pad";
import { makePolyFn } from "./internal/poly_helpers";
(function () {
    var objectPolyfills = {
        "keys": polyObjKeys
    };
    var stringPolyfills = {
        "startsWith": polyStrStartsWith,
        "endsWith": polyStrEndsWith,
        "padStart": polyStrPadStart,
        "padEnd": polyStrPadEnd,
        "trim": polyStrTrim,
        "trimStart": polyStrTrimStart,
        "trimLeft": polyStrTrimStart,
        "trimEnd": polyStrTrimEnd,
        "trimRight": polyStrTrimEnd
    };
    arrForEach(polyObjKeys(objectPolyfills), function (key) {
        if (!ObjClass[key]) {
            ObjClass[key] = makePolyFn(objectPolyfills[key]);
        }
    });
    if (!ArrCls.isArray) {
        ArrCls.isArray = makePolyFn(polyIsArray);
    }
    arrForEach(polyObjKeys(stringPolyfills), function (key) {
        if (!StrProto[key]) {
            StrProto[key] = makePolyFn(stringPolyfills[key]);
        }
    });
})();
//# sourceMappingURL=polyfills.js.map