import { isNullOrUndefined } from "../helpers/base";
import { EMPTY, LENGTH, StrProto } from "../internal/constants";
import { _unwrapFunction } from "../internal/unwrapFunction";
import { mathCeil } from "../math/floor";
import { mathToInt } from "../math/to_int";
import { strRepeat } from "./repeat";
import { strSubstring } from "./substring";
var PAD_START = "padStart";
var PAD_END = "padEnd";
function _padValue(value, targetLength, padString) {
    var result = EMPTY;
    targetLength = mathToInt(targetLength, true);
    targetLength >>= 0;
    var len = value[LENGTH];
    if (len < targetLength) {
        result = isNullOrUndefined(padString) ? " " : "" + padString;
        targetLength = targetLength - len;
        if (targetLength > result[LENGTH]) {
            result = strRepeat(result, mathCeil(targetLength / result[LENGTH]));
        }
        if (result[LENGTH] > targetLength) {
            result = strSubstring(result, 0, targetLength);
        }
    }
    return result;
}
export var strPadStart = StrProto[PAD_START] ? _unwrapFunction(PAD_START) : polyStrPadStart;
export var strPadEnd = StrProto[PAD_END] ? _unwrapFunction(PAD_END) : polyStrPadEnd;
export function polyStrPadStart(value, targetLength, padString) {
    return _padValue(value, targetLength, padString) + value;
}
export function polyStrPadEnd(value, targetLength, padString) {
    return value + _padValue(value, targetLength, padString);
}
//# sourceMappingURL=pad.js.map