import { isString } from "../helpers/base";
import { dumpObj } from "../helpers/diagnostics";
import { throwTypeError } from "../helpers/throw";
import { LENGTH, StrProto } from "../internal/constants";
import { _unwrapFunction } from "../internal/unwrapFunction";
import { strSubstring } from "./substring";
var STARTS_WITH = "startsWith";
export var strStartsWith = StrProto[STARTS_WITH] ? _unwrapFunction(STARTS_WITH) : polyStrStartsWith;
export function polyStrStartsWith(value, searchString, position) {
    if (!isString(value)) {
        throwTypeError("'" + dumpObj(value) + "' is not a string");
    }
    var searchValue = isString(searchString) ? searchString : "" + searchString;
    var chkLen = searchValue[LENGTH];
    var pos = position > 0 ? position : 0;
    return strSubstring(value, pos, pos + chkLen) === searchValue;
}
//# sourceMappingURL=starts_with.js.map