import { SYMBOL } from "../internal/constants";
import { polyGetKnownSymbol, polyNewSymbol, polySymbolFor, polySymbolKeyFor } from "../polyfills/symbol";
import { _wellKnownSymbolMap } from "./well_known";
import { isDefined, _createIs } from "../helpers/base";
import { getInst } from "../helpers/environment";
import { _safeCheck } from "../internal/safe_check";
var _hasSymbol = _safeCheck(function () { return isDefined(Symbol); }, false);
var _symbol = getInst(SYMBOL);
var _symbolFor = _symbol && _safeCheck(function () { return _symbol["for"]; }, null);
var _symbolKeyFor = _symbol && _safeCheck(function () { return _symbol["keyFor"]; }, null);
export var isSymbol = _createIs("symbol");
export function hasSymbol(useCached) {
    return !!getSymbol(useCached);
}
export function getSymbol(useCached) {
    _symbol = useCached === false ? getInst(SYMBOL, useCached) : _symbol;
    return _hasSymbol && _symbol;
}
export function getKnownSymbol(name, noPoly) {
    var knownName = _wellKnownSymbolMap[name];
    return _symbol ? _symbol[knownName || name] : (!noPoly ? polyGetKnownSymbol(name) : null);
}
export function newSymbol(description, noPoly) {
    return _hasSymbol ? Symbol(description) : (!noPoly ? polyNewSymbol(description) : null);
}
export var symbolFor = _symbolFor || polySymbolFor;
export var symbolKeyFor = _symbolKeyFor || polySymbolKeyFor;
//# sourceMappingURL=symbol.js.map